# Enum Class HttpOption.Http3DiscoveryMode

java.lang.Object
java.lang.Enum<HttpOption.Http3DiscoveryMode>
java.net.http.HttpOption.Http3DiscoveryMode

All Implemented Interfaces:
  `Serializable, Comparable<HttpOption.Http3DiscoveryMode>, Constable`

Enclosing interface:
  `HttpOption<T>`

public static enum HttpOption.Http3DiscoveryMode extends Enum<HttpOption.Http3DiscoveryMode>
This enumeration can be used to help the `HttpClient` decide how an HTTP/3 exchange should be established, and can be provided as the value of the `HttpOption.H3_DISCOVERY` option to `Builder.setOption`.

Note that if neither the request preferred version nor the client preferred version is HTTP/3, no HTTP/3 exchange will be established and the `Http3DiscoveryMode` is ignored.

Since:
  26

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ALT_SVC`
  This instructs the `HttpClient` to only use the HTTP Alternative Services to find or establish an HTTP/3 connection with the origin server.
  `ANY`
  This instructs the `HttpClient` to use its own implementation specific algorithm to find or establish a connection for the exchange.
  `HTTP_3_URI_ONLY`
  This instructs the `HttpClient` to only attempt an HTTP/3 connection with the origin server.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static HttpOption.Http3DiscoveryMode`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static HttpOption.Http3DiscoveryMode[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(HttpOption.Http3DiscoveryMode o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<HttpOption.Http3DiscoveryMode>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<HttpOption.Http3DiscoveryMode>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### ANY

    public static final HttpOption.Http3DiscoveryMode ANY
    This instructs the `HttpClient` to use its own implementation specific algorithm to find or establish a connection for the exchange. Typically, if no connection was previously established with the origin server defined by the request URI, the `HttpClient` implementation may attempt to establish both an HTTP/3 connection over QUIC and an HTTP connection over TLS/TCP at the authority present in the request URI, and use the first that succeeds. The exchange may then be carried out with any of the three HTTP protocol versions, depending on which method succeeded first.
    Implementation Note:
      If the request preferred version is HTTP/3, the `HttpClient` may give priority to HTTP/3 by attempting to establish an HTTP/3 connection, before attempting a TLS connection over TCP.

      When attempting an HTTP/3 connection in this mode, the `HttpClient` may use any HTTP Alternative Services information it may have previously obtained from the origin server. If no such information is available, a direct HTTP/3 connection at the authority (host, port) present in the request URI will be attempted.

  - ### ALT_SVC

    public static final HttpOption.Http3DiscoveryMode ALT_SVC
    This instructs the `HttpClient` to only use the HTTP Alternative Services to find or establish an HTTP/3 connection with the origin server. The exchange may then be carried out with any of the three HTTP protocol versions, depending on whether an Alternate Service record for HTTP/3 could be found, and which HTTP version was negotiated with the origin server, if no such record could be found.

    In this mode, requests sent to the origin server will be sent through HTTP/1.1 or HTTP/2 until a `h3` HTTP Alternative Services endpoint for that server is advertised to the client. Usually, an alternate service is advertised by a server when responding to a request, so that subsequent requests can make use of that alternative service.

  - ### HTTP_3_URI_ONLY

    public static final HttpOption.Http3DiscoveryMode HTTP_3_URI_ONLY
    This instructs the `HttpClient` to only attempt an HTTP/3 connection with the origin server. The connection will only succeed if the origin server is listening for incoming HTTP/3 connections over QUIC at the same authority (host, port) as defined in the request URI. In this mode, HTTP Alternative Services are not used.

- ## Method Details

  - ### values

    public static HttpOption.Http3DiscoveryMode[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static HttpOption.Http3DiscoveryMode valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null